/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.kandidatur.entity;

@javax.persistence.NamedQueries(
 {



   
 }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "ERSATZKANDIDATUR")
@javax.persistence.Cacheable
@javax.persistence.PrimaryKeyJoinColumn(name="personendaten_id")
@javax.persistence.DiscriminatorValue(Ersatzkandidatur.DISCRIMINATOR_VALUE)

public
 class Ersatzkandidatur
extends AbstractErsatzkandidatur
  {

  private static final long serialVersionUID = 0L;

  public static final String DISCRIMINATOR_VALUE = "ERSATZKANDIDATUR";

  /**
   * default constructor (protected, da mit CustomData aufgerufen werden muss)
   */
  protected Ersatzkandidatur() {
    super();
  }
    public Ersatzkandidatur(de.ivu.elect.jee.entity.customdata.CustomData customData){
        super(customData);
      }



    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Ersatzkandidatur(Ersatzkandidatur original){
      original.copyEntity(this);
    }


  @Override
  public void resetAttributeChanged() {
        hasChangedDummy = false;
  
  


    super.resetAttributeChanged();
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "DUMMY", nullable = ErsatzkandidaturConstants.DUMMY_NULLABLE, length=ErsatzkandidaturConstants.DUMMY_MAX_LENGTH)
        
  protected java.lang.String dummy =  null;

  @javax.persistence.Transient
  protected boolean hasChangedDummy = false;

  public boolean hasChangedDummy(){
    return hasChangedDummy;
  }
  
  /**
   * 
   *
   * getter for ERSATZKANDIDATUR.DUMMY
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getDummy() {
        return dummy;
      }

  /**
   * 
   *
   * setter for ERSATZKANDIDATUR.DUMMY
   *
   * @param dummy
   */
  @Override   public void setDummy(@javax.annotation.Nullable  java.lang.String dummy) {

       resetTkCache();
                  
                          java.lang.String dummyInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(dummy, ErsatzkandidaturConstants.DUMMY_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.dummy
      , dummyInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedDummy |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("dummy");
      }


      

       this.dummy = dummyInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */

/**
 * Beziehungen N:1 bidirektional
 */
  /**
   * Beziehung N:1 (bidirektional) zu UebergeordneteKandidatur
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.EAGER , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "UEBERGEORDNETE_KANDIDATUR_ID", referencedColumnName="PERSONENDATEN_ID"))
  protected de.ivu.elect.business.kandidatur.entity.Kandidatur uebergeordneteKandidatur;

  /**
   * 
   */
  @Override
  public void setUebergeordneteKandidatur( de.ivu.elect.business.kandidatur.entity.Kandidatur uebergeordneteKandidatur){
    resetTkCache();

    try {
      if (!updateRelationship){
        updateRelationship = true;

    

        if (uebergeordneteKandidatur == null){
          // andere Seite der Beziehung aktualisieren wenn vorher nicht null
          if (this.uebergeordneteKandidatur != null){
            this.uebergeordneteKandidatur.removeErsatzkandidaturByUebergeordneteKandidatur(this);
          }
        } else {
          // andere Seite der Beziehung aktualisieren
          uebergeordneteKandidatur.addErsatzkandidaturByUebergeordneteKandidatur(this);
        }
        this.uebergeordneteKandidatur = uebergeordneteKandidatur;
    
      }
    } finally {
      updateRelationship = false;
    }
  }


/**
* 
* Kein Update der bidirektionalen Beziehung - schneller, aber mit Vorsicht zu genießen
*/
@Override
public void setUebergeordneteKandidaturOhneUpdateBeziehung( de.ivu.elect.business.kandidatur.entity.Kandidatur uebergeordneteKandidatur){
    resetTkCache();
        this.uebergeordneteKandidatur = uebergeordneteKandidatur;
    }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.kandidatur.entity.Kandidatur getUebergeordneteKandidatur(){
    return this.uebergeordneteKandidatur;
  }


  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Ersatzkandidatur:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Ersatzkandidatur other){
        super.copyEntity(other);
                             other.dummy = this.dummy;
           
  other.setUebergeordneteKandidatur(this.getUebergeordneteKandidatur());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Ersatzkandidatur.class)){
        copyEntityAttributesUsingSetter((Ersatzkandidatur) other.castTo(Ersatzkandidatur.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Ersatzkandidatur: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Ersatzkandidatur other){
      super.copyEntityAttributesUsingSetter(other);
               other.setDummy(this.dummy);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }

    @Override
    public void copyEntityAttributesUsingSetter(de.ivu.elect.business.kandidatur.entity.Kandidatur other){
       if (other.isInstanceOf(Ersatzkandidatur.class)) {
         copyEntityAttributesUsingSetter(other.castTo(Ersatzkandidatur.class).getEntity());
       } else {
         super.copyEntityAttributesUsingSetter(other);
       }
    }

  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Ersatzkandidatur other){
       super.copyChangedEntityAttributesUsingSetter(other);
                       if (hasChangedDummy) {
        other.setDummy(this.dummy);
      }
             }

    @Override
    public void copyChangedEntityAttributesUsingSetter(de.ivu.elect.business.kandidatur.entity.Kandidatur other){
      if (other.isInstanceOf(Ersatzkandidatur.class)) {
        copyChangedEntityAttributesUsingSetter(other.castTo(Ersatzkandidatur.class).getEntity());
      } else {
        super.copyChangedEntityAttributesUsingSetter(other);
      }
    }




    @javax.persistence.Transient
    private transient ErsatzkandidaturTK tkCache;

    @Override
    protected void resetTkCache() {
    super.resetTkCache();
        tkCache = null;
    }

    public ErsatzkandidaturTK getErsatzkandidaturTK(){
    if (tkCache==null) {
    tkCache = new ErsatzkandidaturTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getErsatzkandidaturTK();
    }

  @Override
  public ErsatzkandidaturUK getUk(){
    return getErsatzkandidaturUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Ersatzkandidatur.class;
  }

public ErsatzkandidaturUK getErsatzkandidaturUK(){

   return  new ErsatzkandidaturUK(



  );
}

  @javax.persistence.Transient
  private transient ErsatzkandidaturProperties properties;

  @Override
  public ErsatzkandidaturProperties getProperties(){
    if (properties == null) {
      properties = new ErsatzkandidaturProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public ErsatzkandidaturProperties getErsatzkandidaturProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return ErsatzkandidaturConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
        if (super.isAenderungenProtokollieren()){
      return true;
    }
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
            super.setProtokollierteAttributeMitWerten(werteVorher);
                 }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = super.getProtokollierteAttributeMitWerten();
                                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
        super.resetProtokollierteAttribute();
                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
           java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = super.getFachlichAbhaengigeEntitaeten();
                    return result;
  }

        
            @Override
            protected String getInitialDiscriminator() {
              return "ERSATZKANDIDATUR";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  @Override
  public boolean isPersistent() {
    return getId() != null;
  }



            
                  @Override
                public void resetValidation() {
                  super.resetValidation();
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                          @Override
                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                  validationResult.addAll(super.validateEntity());
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(ErsatzkandidaturConstants.DUMMY_MAX_LENGTH ,  dummy, this, ErsatzkandidaturConstants.MESSAGE_KEY_DUMMY_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            }
